VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.ActiveVB.de"
   ClientHeight    =   3495
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4800
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3495
   ScaleWidth      =   4800
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   495
      Left            =   1800
      TabIndex        =   0
      Top             =   1560
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !


'Die erste Variante ist klar langsamer: Stringvergleich eben
'(auf meinem PC, kompiliert: "Is Nothing" ist 30 mal schneller als
'"TypeName", wenn das Objekt tatschlich Nothing ist. Wenn das Objekt
'initialisiert ist, ist die "Is Nothing"-Methode sogar 55 mal schneller!)

'Die anderen beiden Varianten sind da schon wesentlich interessanter:
'aufgrund des Not ist (zumindest kompiliert!) die zweite Variante die
'schnellste. Wenn man jedoch das Gegenteil prfen will, d.h. *ob* ein
'Objekt initialisiert wird, lt man das Not weg und die dritte Variante
'ist die schnellste!


Option Explicit

'Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" ( _
  nDest As Any, _
  nSrc As Any, _
  ByVal nLen As Long _
)

Dim t As xTimer

Private Sub Command1_Click()
    Dim Results     As String
    'Dim StartTime   As INT64
    'Dim StopTime    As INT64
    'Dim Frequency   As INT64
    Dim Duration    As Double
    
    Dim LoopVar     As Long
    Const LOOPLEN   As Long = &HF00000
    
    Dim objDummy    As Collection
    Dim varDummy    As Long
    
    ' Timer initialisieren
    Set t = New xTimer
    
    '----------------------------------------------------
    ' Objekt ist nicht initialisiert
    Results = "Objekt ist nicht initialisiert" & vbNewLine & vbNewLine
    
    ' Methode 1: TypeName()
    t.Calibrieren
    t.Start
    
    For LoopVar = 1 To LOOPLEN
        If TypeName(objDummy) = "Nothing" Then _
            varDummy = varDummy
    Next LoopVar
    
    t.Halt
    Duration = t.RunTime
    
    Results = Results & _
        "Methode TypeName(): " & vbTab & _
        Format$(Duration, "0.###") & vbCrLf
    
    ' Methode 2: Is Nothing
    t.Calibrieren
    t.Start
    
    For LoopVar = 1 To LOOPLEN
        If objDummy Is Nothing Then _
            varDummy = varDummy
    Next LoopVar
    
    t.Halt
    Duration = t.RunTime
    
    Results = Results & _
        "Methode Is Nothing: " & vbTab & _
        Format$(Duration, "0.###") & vbCrLf
    
    ' Methode 3: CBool(ObjPtr())
    t.Calibrieren
    t.Start
    
    For LoopVar = 1 To LOOPLEN
        If Not CBool(ObjPtr(objDummy)) Then _
            varDummy = varDummy
    Next LoopVar
    
    t.Halt
    Duration = t.RunTime
    
    Results = Results & _
        "Methode CBool(ObjPtr()): " & vbTab & _
        Format$(Duration, "0.###") & vbCrLf
    
    '----------------------------------------------------
    ' Objekt ist initialisiert
    Set objDummy = New Collection
    
    Results = Results & vbCrLf & vbCrLf & _
        "Objekt ist initialisiert" & vbNewLine & vbNewLine
    
    ' Methode 1: TypeName()
    t.Calibrieren
    t.Start
    
    For LoopVar = 1 To LOOPLEN
        If TypeName(objDummy) = "Nothing" Then _
            varDummy = varDummy
    Next LoopVar
    
    t.Halt
    Duration = t.RunTime
    
    Results = Results & _
        "Methode TypeName(): " & vbTab & _
        Format$(Duration, "0.###") & vbCrLf
    
    ' Methode 2: Is Nothing
    t.Calibrieren
    t.Start
    
    For LoopVar = 1 To LOOPLEN
        If objDummy Is Nothing Then _
            varDummy = varDummy
    Next LoopVar
    
    t.Halt
    Duration = t.RunTime
    
    Results = Results & _
        "Methode Is Nothing: " & vbTab & _
        Format$(Duration, "0.###") & vbCrLf
    
    ' Methode 3: CBool(ObjPtr())
    t.Calibrieren
    t.Start
    
    For LoopVar = 1 To LOOPLEN
        If Not CBool(ObjPtr(objDummy)) Then _
            varDummy = varDummy
    Next LoopVar
    
    t.Halt
    Duration = t.RunTime
    
    Results = Results & _
        "Methode CBool(ObjPtr()): " & vbTab & _
        Format$(Duration, "0.###") & vbCrLf
    
    '----------------------------------------------------
    ' Resultate anzeigen
    Call MsgBox(Results, vbInformation, "Timingresultate")
    
    Set t = Nothing
End Sub

